

####### Expanded from @PACKAGE_INIT@ by configure_package_config_file() #######
get_filename_component(PACKAGE_PREFIX_DIR "${CMAKE_CURRENT_LIST_DIR}/../../../" ABSOLUTE)

macro(set_and_check _var _file)
  set(${_var} "${_file}")
  if(NOT EXISTS "${_file}")
    message(FATAL_ERROR "File or directory ${_file} referenced by variable ${_var} does not exist !")
  endif()
endmacro()

####################################################################################

set(Lunchbox_PREFIX_DIR ${PACKAGE_PREFIX_DIR})
set(_output_type)
set(_out)
set(_req)
set(_quiet)
set(_fail)

if(Lunchbox_FIND_REQUIRED)
  set(_output_type FATAL_ERROR)
  set(_out 1)
  set(_req REQUIRED)
else()
  set(_output_type STATUS)
  if(NOT Lunchbox_FIND_QUIETLY)
    set(_out 1)
  endif()
endif()
if(Lunchbox_FIND_QUIETLY)
  set(_quiet QUIET)
endif()

if(NOT _fail)
  set(LUNCHBOX_VERSION 1.8.0)
  set_and_check(LUNCHBOX_INCLUDE_DIRS ${Lunchbox_PREFIX_DIR}/include)
  set(LUNCHBOX_DEB_DEPENDENCIES "lunchbox2 (>= 1.8)")
  set(LUNCHBOX_DEB_LIB_DEPENDENCY "lunchbox2-lib (>= 1.8)")
  set(LUNCHBOX_DEB_DEV_DEPENDENCY "lunchbox2-dev (>= 1.8)")

  if(Lunchbox_FIND_COMPONENTS)
    find_library(${UPPER_PROJECT_NAME}_LIBRARY Lunchbox NO_DEFAULT_PATH
                 PATHS ${Lunchbox_PREFIX_DIR} PATH_SUFFIXES lib )
    list(APPEND LUNCHBOX_LIBRARIES ${LUNCHBOX_LIBRARY})
    foreach(_component ${Lunchbox_FIND_COMPONENTS})
      find_library(${_component}_libraryname Lunchbox_${_component} NO_DEFAULT_PATH
        PATHS ${Lunchbox_PREFIX_DIR} PATH_SUFFIXES lib )

      if(${_component}_libraryname MATCHES ${_component}_libraryname-NOTFOUND)
        if(Lunchbox_FIND_REQUIRED_${_component})
          set(_fail "Component library ${_component} not found")
          message(FATAL_ERROR "   Lunchbox_${_component} "
            "not found in ${Lunchbox_PREFIX_DIR}/lib")
        elseif(NOT _quiet)
          message(STATUS "   Lunchbox_${_component} "
            "not found in ${Lunchbox_PREFIX_DIR}/lib")
        endif()
      else()
        string(TOUPPER ${_component} _COMPONENT)
        set(LUNCHBOX_${_COMPONENT}_FOUND TRUE)
        set(LUNCHBOX_${_COMPONENT}_LIBRARY ${${_component}_libraryname})
        list(APPEND LUNCHBOX_LIBRARIES ${${_component}_libraryname})
        list(APPEND LUNCHBOX_COMPONENTS ${_component})
      endif()
    endforeach()
  else()
    set(LUNCHBOX_LIBRARY_NAMES Lunchbox)
    foreach(_libraryname ${LUNCHBOX_LIBRARY_NAMES})
      string(TOUPPER ${_libraryname} _LIBRARYNAME)
      find_library(${_LIBRARYNAME}_LIBRARY ${_libraryname} NO_DEFAULT_PATH
                   PATHS ${Lunchbox_PREFIX_DIR} PATH_SUFFIXES lib )
      if(${_LIBRARYNAME}_LIBRARY MATCHES ${_LIBRARYNAME}_LIBRARY-NOTFOUND)
        set(_fail "${_libraryname} not found")
        if(_out)
          message(${_output_type} "   Missing the Lunchbox "
            "library in ${Lunchbox_PREFIX_DIR}/lib.")
        endif()
      else()
        list(APPEND LUNCHBOX_LIBRARIES ${${_LIBRARYNAME}_LIBRARY})
        string(REPLACE "Lunchbox_" "" _component ${_libraryname})
        string(TOUPPER ${_component} _COMPONENT)
        set(LUNCHBOX_${_COMPONENT}_FOUND TRUE)
        list(APPEND LUNCHBOX_COMPONENTS ${_component})
      endif()
    endforeach()
  endif()

  if(EXISTS ${Lunchbox_PREFIX_DIR}/share/Lunchbox/CMake/options.cmake)
    include(${Lunchbox_PREFIX_DIR}/share/Lunchbox/CMake/options.cmake)
  endif()
endif()

if(_fail)
  set(LUNCHBOX_FOUND)
  set(LUNCHBOX_VERSION)
  set(LUNCHBOX_INCLUDE_DIRS)
  set(LUNCHBOX_LIBRARIES)
  set(LUNCHBOX_DEB_DEPENDENCIES)
  set(LUNCHBOX_LIBRARY)
  set(LUNCHBOX_COMPONENTS)
  if(_out)
    message(STATUS "Could not find Lunchbox: ${_fail}")
  endif()
else()
  set(LUNCHBOX_FOUND TRUE)
  set(LUNCHBOX_MODULE_FILENAME )
  if(_out)
    message(STATUS "Found Lunchbox 1.8.0 ${LUNCHBOX_COMPONENTS} in "
      "${LUNCHBOX_INCLUDE_DIRS}:${LUNCHBOX_LIBRARY}")
  endif()
endif()
